
Summary:      A GUI host for DSSI plugins
Name:         ghostess
Version:      0
Release:      %mkrel 0.20081213
License:      GPL
Group:        Sound
URL:          http://home.jps.net/~musound/index.html
Source0:      ghostess-20081213.tar.bz2
BuildRoot:    %{_tmppath}/%{name}-buildroot
Requires:	jackit >= 0.80.0
Requires:	liblo0
BuildRequires: 	libalsa-devel
BuildRequires:	jackit-devel
BuildRequires: 	dssi-devel
BuildRequires:	liblo-devel
BuildRequires: 	glib2-devel
BuildRequires: 	gtk+2-devel

%description
Ghostess, a rough start at a graphical DSSI host, based on jack-dssi-host, but capable of saving and restoring plugin configuration, as well as specifying MIDI channels and layering synths. ghostess includes both an ALSA sequencer MIDI driver and a (clumsy but functional) CoreMIDI driver, which allows DSSI to be used on Mac OS X. ghostess also comes with a universal DSSI GUI, which attempts to provide GUI services for any DSSI or LADSPA plugin, and may be used with any DSSI host.

This assumes you are familiar with jack-dssi-host. ghostess and jack-dssi-host
both descended from the same dssi_example_host source, and in many ways are
still very similar.

A summary of the differences (as of 2005/4/11):
* ghostess is GPL, jack-dssi-host is BSD-ish.

* ghostess uses GNU autotools.

* ghostess has a simple GTK+ GUI.  Click on the 'UI' button for any instance
to launch or hide its UI.  Right-click on the 'UI' button for more options.

* ghostess comes with a minimal universal DSSI GUI that can be used with any
DSSI or LADSPA plugin. It does not read RDF files or instantiate the plugin,
so it's not as full-featured as a universal GUI could be, but it does allow
for adjusting DSSI/LADSPA ports, selecting bank and program (for plugins
with select_program()), and sending test notes (for plugins with any of the
run_synth() functions).

If ghostess cannot find a UI for a plugin, and the universal GUI is in the
PATH, ghostess will launch it.

* ghostess allows specification of the MIDI channel for each plugin instance,
allowing layering of multiple synths per channel.

* ghostess allows specification of initial configure, program, and port
values from the command line.

* ghostess tracks configure items set on startup or sent by plugin UIs.

* ghostess, through its 'Save Configuration...' menu option, can save the
current configuration of its plugins.  Basically, it just writes a Bourne
shell script that can be used to start a (mostly) identical session.

* ghostess creates a separate MIDI reception thread, and makes it
low-priority SCHED_FIFO if possible (ALSA-only, at the moment).

* ghostess double-forks its plugin UIs, putting them in separate process
groups, and it does not SIGHUP everything on shutdown.
jack-dssi-host keeps the UIs in its process group, and SIGHUPs them all as
it exits (Linux-only, at the moment).

* jack-dssi-host uses dual gettimeofday()s in the MIDI and audio process
threads to do event dejittering, which seems expensive. ghostess uses
jack_frame_time() and jack_last_frame_time(). This means ghostess needs
JACK 0.99.0 or newer.

* ghostess uses the LADSPA plugin Label and port Names when creating JACK
port names, hopefully resulting in short-but-useful port names.

* unlike jack-dssi-host, ghostess will not automatically load a plugin if it
is invoked without arguments via a symlink of the same name as the plugin.

* ghostess passes the JACK audio input buffers directly to plugins,
eliminating a memcpy() that jack-dssi-host does.

* jack-dssi-host includes ~/.dssi in its default for DSSI_PATH, ghostess does
not.

%prep
%setup -q -n ghostess-20081213

%build
#sed -i 's|MIDI_JACK, 1|MIDI_JACK, 0|g' configure.ac
#sed -i 's|AC_DEFINE(MIDI_ALSA, 1,|#AC_DEFINE(MIDI_ALSA, 0,|g' configure.ac

./autogen.sh
%configure2_5x \
	--with-gtk2 \
	--with-jackmidi

#sed -i 's|MIDI_JACK_TRUE@,,|/* #undefine MIDI_JACK_TRUE@,#,|g \
#	s|MIDI_JACK_FALSE@,#,|/* #undefine MIDI_JACK_FALSE@,,|g'  \
#	config.status

%make

%install
rm -rf $RPM_BUILD_ROOT

%makeinstall_std

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc AUTHORS COPYING ChangeLog INSTALL README
%{_bindir}/*


%changelog
* Fri Sep 24 2009 Texstar <texstar at gmail.com> 0.0.20081213
- update and rebuild

* Wed Feb 21 2007 Torbjorn Turpeinen <tobbe@nyvalls.se> 0-0.20061127.1
- Rebuild for pclos2007
- 20061127

* Mon Oct 16 2005 Torbjorn Turpeinen <tobbe@nyvalls.se> 0-0.20050916.1
- 20050916 first build
